var home_dir = "tubes";
var m_img, anim_imgs, count_img, inter, cur_num, img_obj;

function resize_frame(frame){
	if(frame.contentDocument){
		frame.height = frame.contentDocument.documentElement.scrollHeight + 'px';
	} else {
		frame.height = frame.contentWindow.document.body.scrollHeight + 'px';
	}
}

function load_player(id){
    jQuery.ajax({
		type: 'POST',
		url: '/' + home_dir + '/index.php?module=videostream',
		data: 'action=generate_player&vid=' + id,
        beforeSend: function(){
            jQuery("#player").html('<div style="text-align:center"><img src="/' + home_dir + '/templates/skin/assets/images/loading.gif" alt="Loading ..."><br>Loading ...</div>');
        },
		success: function(data){
            jQuery("#player").html(data);
		}
	});
}

function start_animate(obj, imgs){
	img_obj = obj;
	m_img = obj.src;
	anim_imgs = explode(',', base64_decode(imgs));
	reg = /\/([^\/]+).jpg/;
	match = reg.exec(obj.src);
	count_img = anim_imgs.length;

	for (k in anim_imgs){
		if (anim_imgs.hasOwnProperty(k)){
			if (k.match(/^[-\+]?\d+/) !== null){
				s_img = reg.exec(anim_imgs[k]);
				if (anim_imgs[k] == obj.src == match[1] || s_img[1] == match[1]){
					cur_num = k;
				}
			}
		}
	}

	if (cur_num == undefined) cur_num = 0;
	inter = setInterval("anim_img();", 500);
}

function anim_img(){
	cur_num++;
	if (cur_num >= count_img) cur_num = 0;
	img_obj.src = anim_imgs[cur_num];
}

function stop_animate(){
	clearInterval(inter);
	img_obj.src = m_img;
}

function explode(delimiter, string) {
	var emptyArray = {0: ''};

	if (arguments.length != 2 || typeof arguments[0] == 'undefined' || typeof arguments[1] == 'undefined') {
		return null;
	}

	if (delimiter === '' || delimiter === false || delimiter === null) {
		return false;
	}

	if (typeof delimiter == 'function' || typeof delimiter == 'object' || typeof string == 'function' || typeof string == 'object' ) {
		return emptyArray;
	}

	if (delimiter === true) {
		delimiter = '1';
	}

	return string.toString().split (delimiter.toString());
}

function base64_decode(data) {
	var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	var o1, o2, o3, h1, h2, h3, h4, bits, i=0, enc='';

	do {
		h1 = b64.indexOf(data.charAt(i++));
		h2 = b64.indexOf(data.charAt(i++));
		h3 = b64.indexOf(data.charAt(i++));
		h4 = b64.indexOf(data.charAt(i++));

		bits = h1<<18 | h2<<12 | h3<<6 | h4;

		o1 = bits>>16 & 0xff;
		o2 = bits>>8 & 0xff;
		o3 = bits & 0xff;

		if (h3 == 64)	  enc += String.fromCharCode(o1);
		else if (h4 == 64) enc += String.fromCharCode(o1, o2);
		else			   enc += String.fromCharCode(o1, o2, o3);
	} while (i < data.length);

	return enc;
}

function TCO_rotationEngineStartup(tp, wp) {
	TCO_rotationEngineStartup._THUMBS = {};
	if (window['TCO_rotationEngineWaitPeriod']) {
		TCO_rotationEngineStartup._ROTATION_PERIOD_MS = window['TCO_rotationEngineWaitPeriod'] * 1000;
	} else {
		TCO_rotationEngineStartup._ROTATION_PERIOD_MS = wp * 1000;
	}
	TCO_rotationEngineStartup._ROTATION_ID = null;
	TCO_rotationEngineStartup._ROTATION_UID = null;
	TCO_rotationEngineStartup._DUMMY = tp;
}

function TCO_rotationStop(image) {
	if (TCO_rotationEngineStartup._ROTATION_ID) {
		var thumbData = TCO_rotationEngineStartup._THUMBS[TCO_rotationEngineStartup._ROTATION_ID];
		if (thumbData && thumbData['thumb'] && thumbData['thumbInitial']) {
			thumbData['thumb'].src = thumbData['thumbInitial'];
		}
	}
	TCO_rotationEngineStartup._ROTATION_ID = null;
	TCO_rotationEngineStartup._ROTATION_UID = null;
	TCO_rotationEngineStartup._DUMMY = image;
}

function TCO_rotationStart(image, urlPrefix, thumbCount, thumbExt) {
	TCO_rotationStop(null);

	if (image) {
		var currentThumbUrl = image.src;

		var thumbId = image.id;
		if (!thumbId) {
			thumbId = 'TCO_rotationEngineStartup_' + new Date().getTime();
			image.id = thumbId
		}
		var initialIdx = 1;
		if (image.src.indexOf(urlPrefix + initialIdx + (thumbExt ? thumbExt : '.jpg'))>=0)
		{
			initialIdx = 2;
		}
		TCO_rotationEngineStartup._THUMBS[thumbId] = {
			thumb: image,
			thumbInitial: currentThumbUrl,
			prefix: urlPrefix,
			count: thumbCount,
			ext: thumbExt,
			idx: initialIdx - 1
		};

		if (TCO_rotationEngineStartup._THUMBS[thumbId]['thumb']) {
			TCO_rotationEngineStartup._ROTATION_UID = new Date().getTime();
			TCO_rotationEngineStartup._ROTATION_ID = thumbId;
			TCO_rotationInvoke(thumbId, TCO_rotationEngineStartup._ROTATION_UID);
		}
	}
}

function TCO_rotationInvoke(thumbId, uid) {
	var thumbData = TCO_rotationEngineStartup._THUMBS[thumbId];
	if (thumbData) {
		var thumb = thumbData['thumb'];
		var prefix = thumbData['prefix'];
		var count = thumbData['count'];
		var ext = thumbData['ext'];
		var idx = thumbData['idx'];

		idx = (idx == count ? 1 : idx + 1);
		thumbData['idx'] = idx;

		var url = prefix + idx + (ext ? ext : '.jpg');
		var img = new Image();
		img.onload = function() {
			if ((thumbId == TCO_rotationEngineStartup._ROTATION_ID) && (uid == TCO_rotationEngineStartup._ROTATION_UID)) {
				if (img.width == 0) {
					TCO_rotationInvoke(thumbId, uid);
				}
				thumb.src = url;
				setTimeout('TCO_rotationInvoke(\'' + thumbId + '\', ' + uid + ')', TCO_rotationEngineStartup._ROTATION_PERIOD_MS);
			}
		};
		img.onerror = function() {
			if ((thumbId == TCO_rotationEngineStartup._ROTATION_ID) && (uid == TCO_rotationEngineStartup._ROTATION_UID)) {
				TCO_rotationInvoke(thumbId, uid);
			}
		};
		img.src = url;
		TCO_rotationEngineStartup._THUMBS[thumbId] = thumbData;
	}
}