<?php

class Autoloader {
	public static $plugin;
	private static $filename;

	public static function init () {
		spl_autoload_register (['Autoloader', 'autoload_classes']);
		spl_autoload_register (['Autoloader', 'autoload_plugins']);
	}

	private static function autoload_classes ($class_name) {
		self::$filename = CLASSES_DIR . '/' . $class_name . '.class.php';
		if (file_exists (self::$filename)) {
			require_once (self::$filename);
		}
	}

	private static function autoload_plugins ($class_name) {
		self::$filename = PLUGINS_DIR . '/' . self::$plugin . '/' . $class_name . '.php';
		if (file_exists (self::$filename)) {
			require_once (self::$filename);
		}
	}
}